package com.kingdee.eas.custom.risheng;

import java.util.Locale;

import org.apache.log4j.Logger;

import net.sf.json.JSONObject;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.workflow.define.AssignmentEvent;
import com.kingdee.bos.workflow.enactment.IWfAssignment;
import com.kingdee.bos.workflow.enactment.WfAssignment;
import com.kingdee.bos.workflow.enactment.handler.AbstractAssignmentEventHandler;
import com.kingdee.eas.common.EASBizException;

public class AssignmentEventHandler extends AbstractAssignmentEventHandler {

	   private static Logger logger =
	        Logger.getLogger("com.kingdee.eas.custom.risheng.AssignmentEventHandler");
	/**
	 * 
	 */
	private static final long serialVersionUID = -1965097515604467567L;

	@Override
	public void execute(AssignmentEvent assignmentEvent,
			IWfAssignment assignment) {
		// TODO Auto-generated method stub
		WfAssignment assign = (WfAssignment) assignment;
		Context ctx = assign.getContext();
		String assignId = assign.getAssignmentInfo().getAssignmentId();
		logger.error("AssignmentEventHandler:"+assignmentEvent.getName()+","+assignmentEvent);
		JSONObject jsonobject = new JSONObject();
		jsonobject.put("assignId", assignId);
		jsonobject.put("state", assign.getAssignmentInfo().getState().getValue());
		if (AssignmentEvent.OnAssignmentAborted.equals(assignmentEvent)) {
			logger.error("SendTodoMessageTaskHandler:OnAssignmentAborted"+assignId+":assign.getAssignmentInfo().getState():"+assign.getAssignmentInfo().getState().getValue());
			try {
				
			//	TosendMessageFacadeFactory.getLocalInstance(ctx).deleteTodo(jsonobject.toString());
				RishengPendingMessageFacadeFactory.getLocalInstance(ctx).sendDoneMsg(null);
			} catch (EASBizException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (BOSException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}else if(AssignmentEvent.OnAssignmentComplete.equals(assignmentEvent)){
			
			logger.error("SendTodoMessageTaskHandler:OnAssignmentComplete"+assignId+":assign.getAssignmentInfo().getState():"+assign.getAssignmentInfo().getState().getValue());
			try {
				Race race = new Race(ctx,assignId);
				new Thread(race,assignId).start();
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		
	}
	class Race implements Runnable {

		private Context ctx;
		private String jsonobject;
		public Race(Context ctx,String jsonobject){
			this.ctx=ctx;
			this.jsonobject=jsonobject;
		}
		@Override
		public void run() {
			// TODO Auto-generated method stub
			
			try {
				RishengPendingMessageFacadeFactory.getLocalInstance(ctx).sendDoneMsg(null);
			} catch (EASBizException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (BOSException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}
}
